function love.load()
	pie = newDraggable(
		love.graphics.getWidth() / 2,
		love.graphics.getHeight() / 2,
		love.graphics.newImage("cherrypie_obey.jpg"))
	grabbed = false
end

-- =======For click-once dragging=======
--~ function love.update(dt)
	--~ if grabbed then
		--~ pie.x, pie.y = love.mouse.getPosition()
	--~ end
--~ end

-- =======For click-and-hold dragging=======
function love.update(dt)
	local x, y = love.mouse.getPosition()
	if 	love.mouse.isDown("l") and
		contains(x, y, {x = pie.x, y = pie.y, w = pie.w, h = pie.h}) then
		pie.x, pie.y = x-pie.w/2, y-pie.h/2
	end
end

function love.draw()
	love.graphics.draw(pie.img, pie.x, pie.y)
end

function love.keypressed(k)
	if k == "escape" then
		love.event.push("q");
	end
end

--~ function love.mousepressed(x,y,b)
	--~ if b == "l" and contains(x, y, {x = pie.x, y = pie.y, w = pie.w, h = pie.h}) then
		--~ grabbed = true
	--~ end
--~ end

function newDraggable(x, y, img)
	local d = {
		x = x,
		y = y,
		img = img,
	}
	d.w = img:getWidth()
	d.h = img:getHeight()
	return d
end

function within(x,l,u)
	if x < l then return -1
	elseif x > u then return 1
	else return 0 end
end

function contains(x,y,rect)
	if 	within(x, rect.x, rect.x+rect.w) == 0 and 
		within(y, rect.y, rect.y+rect.h) == 0 then
		return true
	end
	return false
end
